<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>ITEA. JS Professional. Lesson 1. Task 2</title>
    <style>
      .post {
        display: flex;
      }
    </style>
  </head>
  <body>
    <div id="renderArea"></div>
    <script>
   //localStorage.removeItem('Likes1');
    /*

      Задание 2.

      Проверка уровня знаний для старта.

      1) Ваша задача используя классы или ф-ю конструктор, создать обьекты этого класса
      которые будут содержать все данные которые есть в обьекте ниже (переменная data),
      а так же будут содержать дополнительное поле likes, которое по умолчанию будет равно нулю.

      2) Дальше, вам необходимо вывести эти сообщения на страницу по шаблону
      (макет находится в папке classworks).

      3) Кнопка like должна обновлять счетчик лайков в этом обьекте и перерисовывать обьект
      на странице

      + бонус:
        - Хранить данные о лайках постов в localStorage и не давать пользователю за один
        заход на страничку поставить больше одного лайка на один пост.
        - После перезагрузки страничка подтягивает данные из localStorage о количестве
        лайков у каждого сообщения

        - Добавить к классу\конструктору поле "answers" (В модель), а в шаблон вывода
        под сообщением инпут в который можно будет добавить комментарий и кнопку для его
        отправки (Макет: js_prof_l1c2_bonus)
        - Комментарии так же хранятся в    и подгружаются после перезагруки
        страницы.

    */

    const data = [
      {
        id: 1,
        link: "#1",
        name: "Established fact",
        description: "The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using 'Content here, content here', making it look like readable English. ",
        image: "http://telegram.org.ru/uploads/posts/2017-10/1507400926_file_162303.jpg"
      },
      { 
        id: 2,
        link: "#2",
        name: "Many packages",
        description: "Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for 'lorem ipsum' will uncover many web sites still in their infancy.",
        image: "http://telegram.org.ru/uploads/posts/2017-10/1507400859_file_162309.jpg"
      },
      {
        id: 3,
        link: "#3",
        name: "Suffered alteration",
        description: "Looked up one of the more obscure Latin words, consectetur, from a Lorem Ipsum passage, and going through the cites of the word in classical literature.",
        image: "http://telegram.org.ru/uploads/posts/2017-10/1507400896_file_162315.jpg"
      },{
        id: 4,
        link: "#4",
        name: "Discovered source",
        description: "It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged",
        image: "http://telegram.org.ru/uploads/posts/2017-10/1507400878_file_162324.jpg"
      },{
        id: 5,
        link: "#5",
        name: "Handful model",
        description: "The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.",
        image: "http://telegram.org.ru/uploads/posts/2017-10/1507400876_file_162328.jpg"
      },
    ];

      let renderArea = document.getElementById('renderArea');
      let template;

      class Post{
        constructor ( id, link, name, description, image, likes, answers){
          this.id = id;
          this.link = link;
          this.name = name;
          this.description = description;
          this.image = image;
          this.likes = 0;
          this.answers = [];
          this.addLike = this.addLike.bind(this);
          this.paint = this.paint.bind(this);
          this.addComment = this.addComment.bind(this)
          this.paintComment = this.paintComment.bind(this)

          //posts.push( this);
        }
        paint () {
          
          this.likes = localStorage.getItem(`Likes${this.id}`);

          if (this.likes == null){
            this.likes = 0;
          }

          template = `
                <div>
                  <img src = "${this.image}" width="200" height="200"></img>
                </div>
                <div>
                    <h1>${this.name}</h1>
                    <p>${this.description}</p>
                    <button class= "likeBtn" data-id="${this.id}">Like!</button>
                    <p id="likes">${this.likes}</p>
                    <div class="forComments" data-id="${this.id}"></div>
                    <input type="textarea" id="comment${this.id}" placeholder="Write your comment">
                    <button class= "sendBtn" data-id="${this.id}">Send</button>
                </div>
              `;

          let findedNode = document.querySelector(`.post[data-id="${this.id}"]`);

          if( findedNode === null ){
              let node = document.createElement('div');
                  node.className = 'post';
                  node.dataset.id = this.id;
                  renderArea.appendChild(node);
              node.innerHTML = template;

          } else {
              findedNode.innerHTML = "";
              findedNode.innerHTML = template;
          }
          
          let btn = document.querySelector(`.likeBtn[data-id="${this.id}"]`);
              btn.addEventListener('click',this.addLike);

          let btn2 = document.querySelector(`.sendBtn[data-id="${this.id}"]`);
              btn2.addEventListener('click',this.addComment);
              //btn.onclick
        }

        addLike () {
          this.likes++;
          localStorage.setItem(`Likes${this.id}`, this.likes);
          this.paint();
          this.paintComment();
        }

        addComment () {
          let commentText = document.getElementById(`comment${this.id}`);
          this.answers.push(commentText.value);
          this.paint();
          this.paintComment();

        }

        paintComment (){
          let divForCom = document.querySelector(`.forComments[data-id="${this.id}"]`);
          let p = document.createElement('p');
          divForCom.appendChild(p);
          p.innerHTML = `Comments(${this.answers.length})`;
          
          for (let i =0; i<this.answers.length; i++){
            let p = document.createElement('p');
            divForCom.appendChild(p);
            p.innerHTML = `${i+1}. ${this.answers[i]}`;
          }
        }

      }

      
      let posts = []; // перенести в класс

      for (let i=0; i < data.length; i++){
        posts[i] = new Post (data[i].id, data[i].link, data[i].name, data[i].description, data[i].image);
        posts[i].paint();
        }

      

    </script>
  </body>
</html>
